<?
  // VStarBlogEngine - install.php
  // (C) 2008-2009 Vladislav Staroselskiy (inet@vladstar.com)

  require "settings.php";

  define('BLOG_INSTALLATION_TITLE', 'VStar Blog installation');

  // --------------------------------------------------------------------------
  // WordPress definitions:

  // Default path to the Wordpress config
  define('WORDPRESS_CONFIG_PATH','../wordpress/wp-config.php');

  // Table names
  define('WP_USERS_TABLE','wp_users');
  define('WP_POSTS_TABLE','wp_posts');
  define('WP_COMMENTS_TABLE','wp_comments');
  define('WP_TAGS_TABLE','wp_terms');
  define('WP_TAGS2POSTS_TABLE','wp_term_relationships');
  define('WP_TERM_TAXONOMY_TABLE','wp_term_taxonomy');

  // Database fields (columns)
  define('WP_USERS_TABLE_ID','ID');
  define('WP_USERS_TABLE_NAME','display_name');
  define('WP_USERS_TABLE_LOGIN','user_login');
  define('WP_USERS_TABLE_EMAIL','user_email');
  define('WP_USERS_TABLE_PASS','user_pass');
  define('WP_USERS_TABLE_STATUS','user_status');

  define('WP_POSTS_TABLE_ID','ID');
  define('WP_POSTS_TABLE_USER_ID','post_author');
  define('WP_POSTS_TABLE_DATETIME','post_date');
  define('WP_POSTS_TABLE_TITLE','post_title');
  define('WP_POSTS_TABLE_CONTENT','post_content');
  define('WP_POSTS_TABLE_POST_STATUS','post_status');
  define('WP_POSTS_TABLE_POST_TYPE','post_type');
  define('WP_POSTS_TABLE_COMMENT_STATUS','comment_status');

  define('WP_COMMENTS_TABLE_ID','comment_ID');
  define('WP_COMMENTS_TABLE_POST_ID','comment_post_ID');
  define('WP_COMMENTS_TABLE_PARENT_ID','comment_parent');
  define('WP_COMMENTS_TABLE_DATETIME','comment_date');
  define('WP_COMMENTS_TABLE_AUTHOR','comment_author');
  define('WP_COMMENTS_TABLE_EMAIL','comment_author_email');
  define('WP_COMMENTS_TABLE_CONTENT','comment_content');
  define('WP_COMMENTS_TABLE_STATUS','comment_approved');
  define('WP_COMMENTS_TABLE_SUBSCRIBE','comment_subscribe');
  define('WP_COMMENTS_TABLE_IP','comment_author_IP');
  define('WP_COMMENTS_TABLE_AGENT','comment_agent');

  define('WP_TAGS_TABLE_ID','term_id');
  define('WP_TAGS_TABLE_NAME','name');

  define('WP_TAGS2POSTS_TABLE_POST_ID','object_id');
  define('WP_TAGS2POSTS_TABLE_TAG_ID','term_taxonomy_id');

  define('WP_TERM_TAXONOMY_TABLE_ID','term_taxonomy_id');
  define('WP_TERM_TAXONOMY_TABLE_TERM_ID','term_id');
  define('WP_TERM_TAXONOMY_TABLE_TAXONOMY','taxonomy');

  // Some permissive field values
  define('WP_POSTS_TABLE_COMMENT_STATUS_OPEN','open');
  define('WP_POSTS_TABLE_COMMENT_STATUS_CLOSE','close');
  define('WP_POSTS_TABLE_POST_STATUS_PUBLIC','publish');
  define('WP_POSTS_TABLE_POST_STATUS_PRIVATE','private');
  define('WP_POSTS_TABLE_POST_STATUS_DRAFT','draft');
  define('WP_COMMENTS_TABLE_SUBSCRIBE_YES','Y');
  define('WP_COMMENTS_TABLE_SUBSCRIBE_NO','N');
  define('WP_COMMENTS_TABLE_STATUS_SPAM','spam');
  define('WP_COMMENTS_TABLE_STATUS_NORMAL','1');
  define('WP_USERS_TABLE_USER_STATUS_NORMAL','0');
  define('WP_USERS_TABLE_USER_STATUS_LOCKED','1');

  define('WP_POST_EXAMPLE_TITLE','Welcome to club !');
  define('WP_POST_EXAMPLE_CONTENT','Welcome ! If you see this message, most likely you are done with the installation procedure. This is only a post example, that you can delete at anytime. Enjoy using VStarBlogEngine ! :) ');

  // --------------------------------------------------------------------------

  // Check if blog database exists
  if (($link = @mysql_connect(BLOG_DATABASE_HOST,BLOG_DATABASE_USER,BLOG_DATABASE_PASSWORD)) && ($db_selected = @mysql_select_db(BLOG_DATABASE_NAME, $link) )) {
    mysql_close($link);
    die ('Sorry, database already exists, you have to rename or delete it first, then will be able to run this installation script again');
  }

  function Import_WP($link,$intable,$outtable,$query) {
    $message="";
    if ($result = mysql_query($query, $link)) {
      $result = mysql_query("SELECT COUNT(*) FROM ".$intable, $link);
      $row=mysql_fetch_row($result);
      $incnt=$row[0];
      $result = mysql_query("SELECT COUNT(*) FROM ".$outtable, $link);
      $row=mysql_fetch_row($result);
      $outcnt=$row[0];
      $message = $outcnt." out of ".$incnt." rows were transferred from ".$intable." to ".$outtable." table<br>\n";
    } else {
      $message = "Import from ".$intable." to ".$outtable." has failed with the following error: ".mysql_error($link).". <b>Query</b>: ".$query."<br>\n";
    }
    return $message;
  }

  session_start();
//  print_r($_SESSION);

  $message="";
  if ($_SERVER["REQUEST_METHOD"]=="POST") {
    if ($_POST["action"]=="Step 1" || ! isset($_SESSION["step"]) || $_SESSION["step"]=="step1") {
      if ($link = @mysql_connect(BLOG_DATABASE_HOST,$_POST["adminname"],$_POST["adminpass"])) {
        if ($db_selected = @mysql_select_db('mysql', $link)) {
          $query = "SELECT User FROM mysql.user WHERE User='".addslashes(BLOG_DATABASE_USER)."' AND Host='".addslashes(BLOG_DATABASE_HOST)."'";
          $result = mysql_query($query, $link);
          if (mysql_num_rows($result)) {
            $_SESSION["blog_user_exists"]='1';
          }
          mysql_close($link);
          $_SESSION["adminname"]=$_POST["adminname"];
          $_SESSION["adminpass"]=$_POST["adminpass"];
          $_SESSION["step"]="step2";
        } else {
          $message.="Sorry, it seems this username does not have enough privileges to add new user.";
        }
      } else {
        $message.="Sorry, it seems you provided wrong admin credentials, please, try again. ";
      }
    } elseif ($_POST["action"]=="Step 2" && isset($_SESSION["step"]) && $_SESSION["step"]=="step2") {
      if (isset($_POST["wp_import"]) && $_POST["wp_import"]=="1" && isset($_POST["wp_config"]) && $_POST["wp_config"]) {
        if (! file_exists($_POST["wp_config"])) {
          $message.="Sorry, it seems file ".$_POST["wp_config"]." does not exist or not readable. ";
        } else {
          $lines = file($_POST["wp_config"]);
          for( $i = 0; $i < sizeof($lines); $i++ )
          {
            if ($command=preg_match("/(^define.*$)/", $lines[$i], $matches )) {
              eval($matches[0]);
            }
          } 
          if (defined("DB_NAME") && defined("DB_USER") && defined("DB_PASSWORD") && defined("DB_HOST")) {
            $_SESSION["wp_name"]=DB_NAME;
            $_SESSION["wp_user"]=DB_USER;
            $_SESSION["wp_pass"]=DB_PASSWORD;
            $_SESSION["wp_host"]=DB_HOST;
            if (defined("DB_CHARSET")) $_SESSION["wp_charset"]=DB_CHARSET;
            $_SESSION["step"]="step3";
          } else {
            $message.="Sorry, the file ".$_POST["wp_config"]." does not seem to be a Wordpress config";
          }
        }
      } else {
        $_SESSION["step"]="step3";
      }
    } elseif ($_POST["action"]=="Step 3" && isset($_SESSION["step"]) && $_SESSION["step"]=="step3") {
      if ($link = @mysql_connect(BLOG_DATABASE_HOST,$_SESSION["adminname"],$_SESSION["adminpass"])) {
        if (isset($_SESSION["blog_user_exists"])) {
          $query="SET PASSWORD FOR '".addslashes(BLOG_DATABASE_USER)."'@'".addslashes(BLOG_DATABASE_HOST)."' = PASSWORD('".md5(rand(0,1000000))."')";
          $result = @mysql_query($query, $link);
          $query = "FLUSH PRIVILEGES";
          $result = @mysql_query($query, $link);
        }
        $query_sets="
CREATE DATABASE IF NOT EXISTS ".BLOG_DATABASE_NAME.";
USE ".BLOG_DATABASE_NAME.";

DROP TABLE IF EXISTS `".BLOG_SPAMFILTERS_TABLE."`;
DROP TABLE IF EXISTS `".BLOG_TAGS2POSTS_TABLE."`;
DROP TABLE IF EXISTS `".BLOG_TAGS_TABLE."`;
DROP TABLE IF EXISTS `".BLOG_COMMENTS_TABLE."`;
DROP TABLE IF EXISTS `".BLOG_POSTS_TABLE."`;
DROP TABLE IF EXISTS `".BLOG_USERS_TABLE."`;

CREATE TABLE `".BLOG_USERS_TABLE."` (
  `".BLOG_USERS_TABLE_ID."` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `".BLOG_USERS_TABLE_LOGIN."` VARCHAR(255) NOT NULL,
  `".BLOG_USERS_TABLE_NAME."` VARCHAR(255) NOT NULL,
  `".BLOG_USERS_TABLE_EMAIL."` VARCHAR(255) NOT NULL,
  `".BLOG_USERS_TABLE_PASS."` VARCHAR(32) NOT NULL,
  `".BLOG_USERS_TABLE_STATUS."` BOOLEAN NOT NULL,
  `".BLOG_USERS_TABLE_SESSION."` VARCHAR(255) NOT NULL,
  `".BLOG_USERS_TABLE_LAST_ACCESS."` DATETIME NOT NULL,
  `".BLOG_USERS_TABLE_LJ_NAME."` VARCHAR(255) NOT NULL,
  `".BLOG_USERS_TABLE_LJ_PASS."` VARCHAR(32) NOT NULL,
  PRIMARY KEY (`".BLOG_USERS_TABLE_ID."`)
)
ENGINE = InnoDB
CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `".BLOG_POSTS_TABLE."` (
  `".BLOG_POSTS_TABLE_ID."` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `".BLOG_POSTS_TABLE_USER_ID."` INTEGER UNSIGNED NOT NULL,
  `".BLOG_POSTS_TABLE_TITLE."` VARCHAR(255) NOT NULL,
  `".BLOG_POSTS_TABLE_CONTENT."` TEXT NOT NULL,
  `".BLOG_POSTS_TABLE_POST_STATUS."` TINYINT(1) UNSIGNED NOT NULL,
  `".BLOG_POSTS_TABLE_COMMENT_STATUS."` BOOLEAN NOT NULL,
  `".BLOG_POSTS_TABLE_SUBSCRIBE."` BOOLEAN NOT NULL,
  `".BLOG_POSTS_TABLE_LJ."` VARCHAR(255) NOT NULL,
  `".BLOG_POSTS_TABLE_LJ_URL."` VARCHAR(255) NOT NULL,
  `".BLOG_POSTS_TABLE_DATETIME."` DATETIME NOT NULL,
  PRIMARY KEY (`".BLOG_POSTS_TABLE_ID."`),
  CONSTRAINT `FK_Posts_User_ID` FOREIGN KEY `FK_Posts_User_ID` (`".BLOG_POSTS_TABLE_USER_ID."`)
    REFERENCES `".BLOG_USERS_TABLE."` (`".BLOG_USERS_TABLE_ID."`)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT,
  INDEX `".BLOG_POSTS_TABLE_DATETIME."` (`".BLOG_POSTS_TABLE_DATETIME."`)
)
ENGINE = InnoDB
CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `".BLOG_COMMENTS_TABLE."` (
  `".BLOG_COMMENTS_TABLE_ID."` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `".BLOG_COMMENTS_TABLE_POST_ID."` INTEGER UNSIGNED NOT NULL,
  `".BLOG_COMMENTS_TABLE_PARENT_ID."` INTEGER UNSIGNED NOT NULL,
  `".BLOG_COMMENTS_TABLE_AUTHOR."` VARCHAR(255) NOT NULL,
  `".BLOG_COMMENTS_TABLE_EMAIL."` VARCHAR(255) NOT NULL,
  `".BLOG_COMMENTS_TABLE_CONTENT."` TEXT NOT NULL,
  `".BLOG_COMMENTS_TABLE_STATUS."` BOOLEAN NOT NULL,
  `".BLOG_COMMENTS_TABLE_SUBSCRIBE."` BOOLEAN NOT NULL,
  `".BLOG_COMMENTS_TABLE_IP."` VARCHAR(15) NOT NULL,
  `".BLOG_COMMENTS_TABLE_AGENT."` VARCHAR(255) NOT NULL,
  `".BLOG_COMMENTS_TABLE_DATETIME."` DATETIME NOT NULL,
  PRIMARY KEY (`".BLOG_COMMENTS_TABLE_ID."`),
  CONSTRAINT `FK_Comments_Post_ID` FOREIGN KEY `FK_Comments_Post_ID` (`".BLOG_COMMENTS_TABLE_POST_ID."`)
    REFERENCES `".BLOG_POSTS_TABLE."` (`".BLOG_POSTS_TABLE_ID."`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  INDEX `".BLOG_COMMENTS_TABLE_DATETIME."` (`".BLOG_COMMENTS_TABLE_DATETIME."`)
)
ENGINE = InnoDB
CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `".BLOG_TAGS_TABLE."` (
  `".BLOG_TAGS_TABLE_ID."` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `".BLOG_TAGS_TABLE_NAME."` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`".BLOG_TAGS_TABLE_ID."`),
  INDEX `Index_Name`(`".BLOG_TAGS_TABLE_NAME."`)
)
ENGINE = InnoDB
CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `".BLOG_TAGS2POSTS_TABLE."` (
  `".BLOG_TAGS2POSTS_TABLE_TAG_ID."` INTEGER UNSIGNED NOT NULL,
  `".BLOG_TAGS2POSTS_TABLE_POST_ID."` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`".BLOG_TAGS2POSTS_TABLE_TAG_ID."`, `".BLOG_TAGS2POSTS_TABLE_POST_ID."`),
  CONSTRAINT `FK_Tags2Posts_Tag_ID` FOREIGN KEY `FK_Tags2Posts_Tag_ID` (`".BLOG_TAGS2POSTS_TABLE_TAG_ID."`)
    REFERENCES `".BLOG_TAGS_TABLE."` (`".BLOG_TAGS_TABLE_ID."`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `FK_Tags2Posts_Post_ID` FOREIGN KEY `FK_Tags2Posts_Post_ID` (`".BLOG_TAGS2POSTS_TABLE_POST_ID."`)
    REFERENCES `".BLOG_POSTS_TABLE."` (`".BLOG_POSTS_TABLE_ID."`)
    ON DELETE CASCADE
    ON UPDATE CASCADE
)
ENGINE = InnoDB
CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `".BLOG_SPAMFILTERS_TABLE."` (
  `".BLOG_SPAMFILTERS_TABLE_ID."` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `".BLOG_SPAMFILTERS_TABLE_KEYWORD."` VARCHAR(255) NOT NULL,
  `".BLOG_SPAMFILTERS_TABLE_TYPE."` TINYINT(1) UNSIGNED NOT NULL,
  PRIMARY KEY (`".BLOG_SPAMFILTERS_TABLE_ID."`),
  INDEX `".BLOG_SPAMFILTERS_TABLE_KEYWORD."`(`".BLOG_SPAMFILTERS_TABLE_KEYWORD."`)
)
ENGINE = InnoDB
CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `".BLOG_LJ_SYNC_POSTS_TABLE."` (
  `".BLOG_LJ_SYNC_POSTS_TABLE_ID."` int(10) unsigned NOT NULL auto_increment,
  `".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID."` int(10) unsigned NOT NULL,
  `".BLOG_LJ_SYNC_POSTS_TABLE_DATETIME."` datetime NOT NULL,
  `".BLOG_LJ_SYNC_POSTS_TABLE_TITLE."` varchar(255) NOT NULL,
  `".BLOG_LJ_SYNC_POSTS_TABLE_CONTENT."` text NOT NULL,
  `".BLOG_LJ_SYNC_POSTS_TABLE_TAGS."` varchar(255) NOT NULL,
  `".BLOG_LJ_SYNC_POSTS_TABLE_SECURITY."` varchar(255) NOT NULL,
  `".BLOG_LJ_SYNC_POSTS_TABLE_URL."` varchar(255) NOT NULL,
  `".BLOG_LJ_SYNC_POSTS_TABLE_ACTION."` varchar(1) NOT NULL,
  PRIMARY KEY  (`".BLOG_LJ_SYNC_POSTS_TABLE_ID."`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `".BLOG_LJ_SYNC_COMMENTS_TABLE."` (
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_ID."` int(10) unsigned NOT NULL auto_increment,
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_POSTERID."` int(10) unsigned NOT NULL,
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_STATE."` varchar(1) NOT NULL,
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_JITEMID."` int(10) unsigned NOT NULL,
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_PARENTID."` int(10) unsigned NOT NULL,
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_SUBJECT."` varchar(255) NOT NULL,
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_BODY."` text NOT NULL,
  `".BLOG_LJ_SYNC_COMMENTS_TABLE_DATE."` datetime NOT NULL,
  PRIMARY KEY  (`".BLOG_LJ_SYNC_COMMENTS_TABLE_ID."`),
  INDEX`".BLOG_LJ_SYNC_COMMENTS_TABLE_JITEMID."` (`".BLOG_LJ_SYNC_COMMENTS_TABLE_JITEMID."`),
  INDEX `".BLOG_LJ_SYNC_COMMENTS_TABLE_DATE."` (`".BLOG_LJ_SYNC_COMMENTS_TABLE_DATE."`),
  INDEX `".BLOG_LJ_SYNC_COMMENTS_TABLE_PARENTID."` (`".BLOG_LJ_SYNC_COMMENTS_TABLE_PARENTID."`),
  INDEX `".BLOG_LJ_SYNC_COMMENTS_TABLE_POSTERID."` (`".BLOG_LJ_SYNC_COMMENTS_TABLE_POSTERID."`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `".BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE."` (
  `".BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE_ID."` int(10) unsigned NOT NULL auto_increment,
  `".BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE_POSTERID."` int(10) unsigned NOT NULL,
  `".BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE_STATE."` varchar(1) NOT NULL,
  PRIMARY KEY  (`".BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE_ID."`),
  INDEX `".BLOG_LJ_SYNC_COMMENTS_TABLE_POSTERID."` (`".BLOG_LJ_SYNC_COMMENTS_TABLE_POSTERID."`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `".BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE."` (
  `".BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE_ID."` int(10) unsigned NOT NULL auto_increment,
  `".BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE_USER."` varchar(255) NOT NULL,
  PRIMARY KEY  (`".BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE_ID."`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

";
        foreach(preg_split("/;/",$query_sets) as $query) {
          $result = @mysql_query($query, $link);
        }
        $message.="Database ".BLOG_DATABASE_NAME." was successfully created.<br>\n";
        $_SESSION["step"]="step4";
      }
    } elseif ($_POST["action"]=="Step 4" && isset($_SESSION["step"]) && $_SESSION["step"]=="step4") {
      if ($link = @mysql_connect(BLOG_DATABASE_HOST,$_SESSION["adminname"],$_SESSION["adminpass"])) {
        $db_selected = @mysql_select_db(BLOG_DATABASE_NAME, $link);
        if (isset($_SESSION["wp_name"]) && isset($_SESSION["wp_user"]) && isset($_SESSION["wp_pass"]) && isset($_SESSION["wp_host"]) && $_SESSION["wp_name"] && $_SESSION["wp_user"] && $_SESSION["wp_pass"] && $_SESSION["wp_host"]) {
          // Check whether threaded comments and subscriptions are installed
          $result = mysql_query("SHOW COLUMNS FROM ".$_SESSION["wp_name"].".".WP_COMMENTS_TABLE." LIKE '".WP_COMMENTS_TABLE_PARENT_ID."'");
          if (! $result || ! mysql_num_rows($result)) {
            $_SESSION["nothreadedcomments"]=1;
          }
          $result = mysql_query("SHOW COLUMNS FROM ".$_SESSION["wp_name"].".".WP_COMMENTS_TABLE." LIKE '".WP_COMMENTS_TABLE_SUBSCRIBE."'");
          if (! $result || ! mysql_num_rows($result)) {
            $_SESSION["nosubscriptions"]=1;
          }
          $message.=Import_WP($link, $_SESSION["wp_name"].".".WP_USERS_TABLE, BLOG_DATABASE_NAME.".".BLOG_USERS_TABLE, "INSERT IGNORE INTO ".BLOG_DATABASE_NAME.".".BLOG_USERS_TABLE." (".implode(",",array(BLOG_USERS_TABLE_ID,BLOG_USERS_TABLE_NAME,BLOG_USERS_TABLE_LOGIN,BLOG_USERS_TABLE_EMAIL,BLOG_USERS_TABLE_PASS,BLOG_USERS_TABLE_STATUS)).") SELECT ".implode(",",array(WP_USERS_TABLE_ID,WP_USERS_TABLE_NAME,WP_USERS_TABLE_LOGIN,WP_USERS_TABLE_EMAIL,WP_USERS_TABLE_PASS,"IF(".WP_USERS_TABLE_STATUS."='".WP_USERS_TABLE_USER_STATUS_NORMAL."','".WP_USERS_TABLE_USER_STATUS_NORMAL."','".WP_USERS_TABLE_USER_STATUS_LOCKED."')"))." FROM ".$_SESSION["wp_name"].".".WP_USERS_TABLE);
          $message.=Import_WP($link, $_SESSION["wp_name"].".".WP_POSTS_TABLE, BLOG_DATABASE_NAME.".".BLOG_POSTS_TABLE, "INSERT IGNORE INTO ".BLOG_DATABASE_NAME.".".BLOG_POSTS_TABLE." (".implode(",",array(BLOG_POSTS_TABLE_ID,BLOG_POSTS_TABLE_USER_ID,BLOG_POSTS_TABLE_DATETIME,BLOG_POSTS_TABLE_TITLE,BLOG_POSTS_TABLE_CONTENT,BLOG_POSTS_TABLE_POST_STATUS,BLOG_POSTS_TABLE_COMMENT_STATUS)).") SELECT ".implode(",",array(WP_POSTS_TABLE.".".WP_POSTS_TABLE_ID,WP_POSTS_TABLE.".".WP_POSTS_TABLE_USER_ID,WP_POSTS_TABLE.".".WP_POSTS_TABLE_DATETIME,WP_POSTS_TABLE.".".WP_POSTS_TABLE_TITLE,WP_POSTS_TABLE.".".WP_POSTS_TABLE_CONTENT,"IF(".WP_POSTS_TABLE.".".WP_POSTS_TABLE_POST_STATUS."='".WP_POSTS_TABLE_POST_STATUS_PUBLIC."','".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC."','".BLOG_POSTS_TABLE_POST_STATUS_PRIVATE."')","IF(".WP_POSTS_TABLE.".".WP_POSTS_TABLE_COMMENT_STATUS."='".WP_POSTS_TABLE_COMMENT_STATUS_OPEN."','".BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN."','".BLOG_POSTS_TABLE_COMMENT_STATUS_CLOSE."')"))." FROM ".$_SESSION["wp_name"].".".WP_POSTS_TABLE." LEFT JOIN ".BLOG_USERS_TABLE." ON ".WP_POSTS_TABLE.".".WP_POSTS_TABLE_USER_ID."=".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_ID." WHERE ".WP_POSTS_TABLE.".".WP_POSTS_TABLE_POST_TYPE."='post' AND ".BLOG_USERS_TABLE.".".BLOG_USERS_TABLE_ID." IS NOT NULL");
          $message.=Import_WP($link, $_SESSION["wp_name"].".".WP_COMMENTS_TABLE, BLOG_DATABASE_NAME.".".BLOG_COMMENTS_TABLE, "INSERT IGNORE INTO ".BLOG_DATABASE_NAME.".".BLOG_COMMENTS_TABLE." (".implode(",",array(BLOG_COMMENTS_TABLE_ID,BLOG_COMMENTS_TABLE_POST_ID,BLOG_COMMENTS_TABLE_PARENT_ID,BLOG_COMMENTS_TABLE_DATETIME,BLOG_COMMENTS_TABLE_AUTHOR,BLOG_COMMENTS_TABLE_EMAIL,BLOG_COMMENTS_TABLE_CONTENT,BLOG_COMMENTS_TABLE_STATUS,BLOG_COMMENTS_TABLE_SUBSCRIBE,BLOG_COMMENTS_TABLE_IP,BLOG_COMMENTS_TABLE_AGENT)).") SELECT ".implode(",",array(WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_ID,WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_POST_ID,(isset($_SESSION["nothreadedcomments"])?"''":WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_PARENT_ID),WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_DATETIME,WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_AUTHOR,WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_EMAIL,WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_CONTENT,"IF(".WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_STATUS."='".WP_COMMENTS_TABLE_STATUS_SPAM."','".BLOG_COMMENTS_TABLE_STATUS_SPAM."','".BLOG_COMMENTS_TABLE_STATUS_NORMAL."')",(isset($_SESSION["nosubscriptions"])?"''":"IF(".WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_SUBSCRIBE."='".WP_COMMENTS_TABLE_SUBSCRIBE_YES."','".BLOG_COMMENTS_TABLE_SUBSCRIBE_YES."','".WP_COMMENTS_TABLE_SUBSCRIBE_NO."')"),WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_IP,WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_AGENT))." FROM ".$_SESSION["wp_name"].".".WP_COMMENTS_TABLE." LEFT JOIN ".BLOG_POSTS_TABLE." ON ".WP_COMMENTS_TABLE.".".WP_COMMENTS_TABLE_POST_ID."=".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID." IS NOT NULL");
          $message.=Import_WP($link, $_SESSION["wp_name"].".".WP_TAGS_TABLE, BLOG_DATABASE_NAME.".".BLOG_TAGS_TABLE, "INSERT IGNORE INTO ".BLOG_DATABASE_NAME.".".BLOG_TAGS_TABLE." (".implode(",",array(BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID,BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_NAME)).") SELECT ".implode(",",array(WP_TAGS_TABLE.".".WP_TAGS_TABLE_ID,WP_TAGS_TABLE.".".WP_TAGS_TABLE_NAME))." FROM ".$_SESSION["wp_name"].".".WP_TAGS_TABLE.",".$_SESSION["wp_name"].".".WP_TERM_TAXONOMY_TABLE." WHERE ".$_SESSION["wp_name"].".".WP_TAGS_TABLE.".".WP_TAGS_TABLE_ID."=".WP_TERM_TAXONOMY_TABLE.".".WP_TERM_TAXONOMY_TABLE_TERM_ID." AND (".WP_TERM_TAXONOMY_TABLE_TAXONOMY."='category' OR ".WP_TERM_TAXONOMY_TABLE_TAXONOMY."='post_tag')");
          $message.=Import_WP($link, $_SESSION["wp_name"].".".WP_TAGS2POSTS_TABLE, BLOG_DATABASE_NAME.".".BLOG_TAGS2POSTS_TABLE, "INSERT IGNORE INTO ".BLOG_DATABASE_NAME.".".BLOG_TAGS2POSTS_TABLE." (".implode(",",array(BLOG_TAGS2POSTS_TABLE_POST_ID,BLOG_TAGS2POSTS_TABLE_TAG_ID)).") SELECT ".implode(",",array(WP_TAGS2POSTS_TABLE.".".WP_TAGS2POSTS_TABLE_POST_ID,BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID))." FROM  ".$_SESSION["wp_name"].".".WP_TAGS2POSTS_TABLE." LEFT JOIN ".BLOG_DATABASE_NAME.".".BLOG_POSTS_TABLE." ON ".WP_TAGS2POSTS_TABLE.".".WP_TAGS2POSTS_TABLE_POST_ID."=".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID." LEFT JOIN ".$_SESSION["wp_name"].".".WP_TERM_TAXONOMY_TABLE." ON ".WP_TAGS2POSTS_TABLE.".".WP_TAGS2POSTS_TABLE_TAG_ID."=".WP_TERM_TAXONOMY_TABLE.".".WP_TERM_TAXONOMY_TABLE_ID." LEFT JOIN ".BLOG_DATABASE_NAME.".".BLOG_TAGS_TABLE." ON ".WP_TERM_TAXONOMY_TABLE.".".WP_TERM_TAXONOMY_TABLE_TERM_ID."=".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID." IS NOT NULL AND ".BLOG_TAGS_TABLE.".".BLOG_TAGS_TABLE_ID." IS NOT NULL AND (".WP_TERM_TAXONOMY_TABLE_TAXONOMY."='category' OR ".WP_TERM_TAXONOMY_TABLE_TAXONOMY."='post_tag')");
          if (count($_POST["I"])) {
            foreach($_POST["I"] as $id) {
              $query="UPDATE ".BLOG_USERS_TABLE." SET ".BLOG_USERS_TABLE_PASS."='".md5($_POST["P_".$id])."',".BLOG_USERS_TABLE_STATUS."='".$_POST["S_".$id]."' WHERE ID='".$id."'";
              $result = mysql_query($query, $link);
            }
          }
        } else { 
          $message.="Import of Wordpress database was skipped.<br>\n";
          if ($_POST["L"] && $_POST["P"]) {
            $query="INSERT INTO ".BLOG_USERS_TABLE." (".BLOG_USERS_TABLE_LOGIN.",".BLOG_USERS_TABLE_NAME.",".BLOG_USERS_TABLE_EMAIL.",".BLOG_USERS_TABLE_PASS.",".BLOG_USERS_TABLE_STATUS.") VALUES ('".addslashes($_POST["L"])."','".(isset($_POST["F"])&&trim($_POST["F"])?addslashes($_POST["F"]):$_POST["L"])."','".(isset($_POST["E"])&&trim($_POST["E"])?addslashes($_POST["E"]):"")."','".md5($_POST["P"])."','".BLOG_USERS_TABLE_USER_STATUS_ADMIN."')";
            $result = mysql_query($query, $link);
            $query="INSERT INTO ".BLOG_POSTS_TABLE." (".BLOG_POSTS_TABLE_USER_ID.",".BLOG_POSTS_TABLE_DATETIME.",".BLOG_POSTS_TABLE_TITLE.",".BLOG_POSTS_TABLE_CONTENT.") VALUES ('1',NOW(),'".addslashes(WP_POST_EXAMPLE_TITLE)."','".addslashes(WP_POST_EXAMPLE_CONTENT)."')";
            $result = mysql_query($query, $link);
            $message.="User '".$_POST["F"]." (".$_POST["L"].")' and a post example are being created.<br>\n";
          }
        }
        $_SESSION["step"]="step5";
        mysql_close($link);
      }
    } elseif ($_POST["action"]=="Complete" && isset($_SESSION["step"]) && $_SESSION["step"]=="step5") {

      if ($link = @mysql_connect(BLOG_DATABASE_HOST,$_SESSION["adminname"],$_SESSION["adminpass"])) {
        if (isset($_SESSION["blog_user_exists"])) {
          $query="SET PASSWORD FOR '".addslashes(BLOG_DATABASE_USER)."'@'".addslashes(BLOG_DATABASE_HOST)."' = PASSWORD('".BLOG_DATABASE_PASSWORD."')";
          $result = mysql_query($query, $link);
        } else {
          $query="CREATE USER '".addslashes(BLOG_DATABASE_USER)."'@'".addslashes(BLOG_DATABASE_HOST)."' IDENTIFIED BY '".BLOG_DATABASE_PASSWORD."'";
          $result = mysql_query($query, $link);
        }
        $query="GRANT SELECT, INSERT, UPDATE, DELETE ON ".BLOG_DATABASE_NAME.".* TO '".addslashes(BLOG_DATABASE_USER)."'@'".addslashes(BLOG_DATABASE_HOST)."'";
        $result = mysql_query($query, $link);
        $query = "FLUSH PRIVILEGES";
        $result = mysql_query($query, $link);

        mysql_close($link);
        $_SESSION["step"]="finish";
      }
    }
  }

?>
<html lang="<?=BLOG_LANGUAGE?>">

<head>
  <title><?=$_SERVER["SERVER_NAME"]." - ".BLOG_INSTALLATION_TITLE?></title>
<?
  include "head.inc";
?>
</head>

<body>

  <h1 class="blog_install"><?=BLOG_INSTALLATION_TITLE?></h1>
  <form method="post">

<?
  if ($message) print "<p class=\"message\">".$message."</p>\n";

  if (! isset($_SESSION["step"]) || $_SESSION["step"]=="step1") {
?>
  <p class="blog_install">In order to create a new database and a user (if not exist), you have to specify correct database admin username and password. It will not be stored anywhere, only for running this installation procedure once. I suggest to check <b>settings.php</b> file prior to running it. MAKE SURE you changed default username/password for the user, that will be accessing blog database - this is very important. Press <b>Step 1</b> to perform checks.</p>
  <b>Database admin username</b>:<br><input type="text" name="adminname" value="<?=isset($_POST["name"])?$_POST["name"]:BLOG_DATABASE_USER?>"><br>
  <b>Database admin password</b>:<br><input type="password" name="adminpass" value=""><br>
  <p class="blog_install"><input type="submit" name="action" value="Step 1"></p>
<?
  } elseif (isset($_SESSION["adminname"]) && isset($_SESSION["adminpass"]) && isset($_SESSION["step"]) && $_SESSION["step"]=="step2") {
?>
  <p class="blog_install">Here you can specify whether you want to import existing Wordpress database into it or not.</p>
  <br><b>Try to import Wordpress database</b>: <input type="checkbox" name="wp_import" value="1"<?=(isset($_POST["wp_import"])&&$_POST["wp_import"]=="1"?" checked":"")?>><br>
  <b>Path to Wordpress config</b>: <input type="text" name="wp_config" size=40 value="<?=(isset($_POST["wp_config"])&&$_POST["wp_config"]?$_POST["wp_config"]:WORDPRESS_CONFIG_PATH)?>"><br>
  <p class="blog_install"><input type="submit" name="action" value="Step 2"></p>
<?
  } elseif (isset($_SESSION["adminname"]) && isset($_SESSION["adminpass"]) && isset($_SESSION["step"]) && $_SESSION["step"]=="step3") {
?>
  <p class="blog_install">We are ready to create a database structure<?=(isset($_SESSION["wp_user"])?" and import Wordpress database into it":"").".".(isset($_SESSION["blog_user_exists"])?" It seems, your user already exists, I will temporary assign a random password to it for now, and will change it to the one, specified at settings.php file at the end of installation. ":"")?>. Press <b>Step 3</b> to continue.</p>
  <b>Database name</b>: <?=BLOG_DATABASE_NAME?><br>
  <b>Tables</b>: <?=BLOG_USERS_TABLE.", ".BLOG_POSTS_TABLE.", ".BLOG_COMMENTS_TABLE.", ".BLOG_TAGS_TABLE.", ".BLOG_TAGS2POSTS_TABLE.", ".BLOG_TAGS2POSTS_TABLE?><br>
  <p class="blog_install"><input type="submit" name="action" value="Step 3"></p>
<?
  } elseif (isset($_SESSION["adminname"]) && isset($_SESSION["adminpass"]) && isset($_SESSION["step"]) && $_SESSION["step"]=="step4") {
    if (isset($_SESSION["wp_name"]) && isset($_SESSION["wp_user"]) && isset($_SESSION["wp_pass"]) && isset($_SESSION["wp_host"])) {
?>
  <p class="blog_install">Now we can try to import existing Wordpress database into blog. You will need to select users from the list below and provide each user with a password and status. Make sure at least one user has admin rights. Press <b>Step 4</b> to continue.</p>
  <b>Wordpress hostname</b>: <?=$_SESSION["wp_host"]?><br>
  <b>Wordpress database</b>: <?=$_SESSION["wp_name"]?><br>
  <b>Blog hostname</b>: <?=BLOG_DATABASE_HOST?><br>
  <b>Blog database</b>: <?=BLOG_DATABASE_NAME?><br>
<?
      if ($link = @mysql_connect(BLOG_DATABASE_HOST,$_SESSION["adminname"],$_SESSION["adminpass"])) {
        $query="SELECT * FROM ".$_SESSION["wp_name"].".".WP_USERS_TABLE;
        $result = mysql_query($query, $link);
        if (mysql_num_rows($result)) {
?>
  <table class="blog_install">
  <tr class="blog_install"><th class="blog_install">Username</th><th class="blog_install">Password</th><th class="blog_install">Status</th></tr>
<?
          while ($u = mysql_fetch_assoc($result)) {
            print "<input type=\"hidden\" name=\"I[]\" value=\"".$u["ID"]."\"><tr class=\"blog_install\"><td class=\"blog_install\">".$u["user_nicename"]." (".$u["user_login"].")</td><td class=\"blog_install\"><input type=\"password\" name=\"P_".$u["ID"]."\"></td><td class=\"blog_install\"><input type=\"radio\" name=\"S_".$u["ID"]."\" value=\"".BLOG_USERS_TABLE_USER_STATUS_LOCKED."\"> Locked&nbsp;&nbsp;&nbsp;<input type=\"radio\" name=\"S_".$u["ID"]."\" value=\"".BLOG_USERS_TABLE_USER_STATUS_COMMENTER."\"> ".BLOG_USERS_TABLE_USER_STATUS_COMMENTER_NAME."&nbsp;&nbsp;&nbsp;<input type=\"radio\" name=\"S_".$u["ID"]."\" value=\"".BLOG_USERS_TABLE_USER_STATUS_REGULAR."\"> ".BLOG_USERS_TABLE_USER_STATUS_REGULAR_NAME."&nbsp;&nbsp;&nbsp;<input type=\"radio\" name=\"S_".$u["ID"]."\" value=\"".BLOG_USERS_TABLE_USER_STATUS_ADMIN."\"> Admin</td></tr>\n";
          }
        }
        mysql_close($link);
      }
?>
  </table>
<?
    } else {
?>
  <p class="blog_install">You did not request Wordpress import. Please, fill out fields below to create a blog admin and then press <b>Step 4</b> to continue.</p>
  <table class="blog_install">
  <tr class="blog_install"><th class="blog_install">Login name</th><th class="blog_install">Fullname</th><th class="blog_install">E-Mail</th><th class="blog_install">Password</th></tr>
  <tr class="blog_install"><td class="blog_install"><input type="text" name="L" value="<?=isset($_POST["L"])?$_POST["L"]:""?>"></td><td class="blog_install"><input type="text" name="F" value="<?=isset($_POST["F"])?$_POST["F"]:""?>"></td><td class="blog_install"><input type="text" name="E" value="<?=isset($_POST["E"])?$_POST["E"]:""?>"></td><td class="blog_install"><input type="password" name="P"></td><td class="blog_install"></td></tr>
  </table>
<?
    }
?>
  <p class="blog_install"><input type="submit" name="action" value="Step 4"></p>
<?
  } elseif (isset($_SESSION["adminname"]) && isset($_SESSION["adminpass"]) && isset($_SESSION["step"]) && $_SESSION["step"]=="step5") {
?>
  <p class="blog_install">As a last step, we are going to create a user, that will be accessing blog database. Press <b>Complete</b> to complete installation.</p>
  <b>Blog username</b>:<br><?=BLOG_DATABASE_USER?> <small>(<?=$_SESSION["blog_user_exists"]?"already exists, password now will be updated to the one, specified in settings.php":"will be created"?>)</small><br>
  <b>Blog database</b>:<br><?=BLOG_DATABASE_NAME?><br>
  <p class="blog_install"><input type="submit" name="action" value="Complete"></p>
<?
  } elseif (isset($_SESSION["step"]) && $_SESSION["step"]=="finish") {
    session_destroy();
?>
  <p class="blog_install">All session variables (including your database admin credentials) were now forgotten. Your blog is ready, please, try to open it from your web browser. You will not be able to use installation script anymore, until you delete blog database and/or blog user.<br>Good luck !</p>
  <p>Click <a href="./">here</a> to continue.</p>
<?
  }
?>
  </form>

</body>
</html>